package com.gic.enterprise.web.controller;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.enterprise.dto.*;
import com.gic.enterprise.qo.RecordQO;
import com.gic.enterprise.service.BillingRecordApiService;
import com.gic.enterprise.service.DictApiService;
import com.gic.enterprise.utils.ResultControllerUtils;
import com.gic.enterprise.utils.UserDetailUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019/8/22 16:33
 */
@RestController
public class BillingRecordController {

    @Autowired
    private BillingRecordApiService billingRecordApiService;
    @Autowired
    private DictApiService dictApiService;

    @RequestMapping("/list-account-balance")
    public RestResponse listAccountBalanceRecord(RecordQO recordQO) {
        recordQO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Page<AccountBalanceRecordDTO>> serviceResponse = billingRecordApiService.listAccountBalanceRecord(recordQO);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/list-double-calling")
    public RestResponse listDoubleCallingRecord(RecordQO recordQO) {
        recordQO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Page<DoubleCallingRecordDTO>> serviceResponse = billingRecordApiService.listDoubleCallingRecord(recordQO);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/list-recording-storage")
    public RestResponse listRecordingStorageRecord(RecordQO recordQO) {
        recordQO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Page<RecordingStorageRecordDTO>> serviceResponse = billingRecordApiService.listRecordingStorageRecord(recordQO);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/list-sms-package")
    public RestResponse listSmsPackageRecord(RecordQO recordQO) {
        recordQO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Page<SmsPackageRecordDTO>> serviceResponse = billingRecordApiService.listSmsPackageRecord(recordQO);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/list-sms")
    public RestResponse listSmsRecord(RecordQO recordQO) {
        recordQO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Page<SmsRecordDTO>> serviceResponse = billingRecordApiService.listSmsRecord(recordQO);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/list-international-sms")
    public RestResponse listInternationalSmsRecord(RecordQO recordQO) {
        recordQO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Page<InternationalSmsRecordDTO>> serviceResponse = billingRecordApiService.listInternationalSmsRecord(recordQO);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/list-voice-code")
    public RestResponse listVoiceCodeRecord(RecordQO recordQO) {
        recordQO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Page<VoiceCodeRecordDTO>> serviceResponse = billingRecordApiService.listVoiceCodeRecord(recordQO);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/list-fee")
    public RestResponse listFee(String startTime, String endTime) {
        ServiceResponse<List<Map<String, Object>>> serviceResponse = billingRecordApiService.listFee(UserDetailUtils.getUserDetail().getEnterpriseId(), startTime, endTime);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/list-sms-app-type")
    public RestResponse listSmsAppType() {
        ServiceResponse<List<DictDTO>> serviceResponse = dictApiService.listSmsAppType();
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    

}
